using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using NineRays.Windows.Forms;
using NineRays.Windows.Forms.Data;
using NineRays.Windows.Forms.Grids;

namespace CheckedDropdowns
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    private NineRays.Windows.Forms.FlyGrid colGrid;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
      this.colGrid = new NineRays.Windows.Forms.FlyGrid();
      ((System.ComponentModel.ISupportInitialize)(this.colGrid)).BeginInit();
      this.SuspendLayout();
      // 
      // colGrid
      // 
      this.colGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right)));
      this.colGrid.BackColor = System.Drawing.SystemColors.Info;
      // 
      // todoList.Columns
      // 
      this.colGrid.Columns.Options = ((NineRays.Windows.Forms.Grids.ColumnsOptions)((((((NineRays.Windows.Forms.Grids.ColumnsOptions.ShowHeaders | NineRays.Windows.Forms.Grids.ColumnsOptions.Sizable) 
        | NineRays.Windows.Forms.Grids.ColumnsOptions.Clickable) 
        | NineRays.Windows.Forms.Grids.ColumnsOptions.ShowTooltips) 
        | NineRays.Windows.Forms.Grids.ColumnsOptions.ShowSortOrderMark) 
        | NineRays.Windows.Forms.Grids.ColumnsOptions.ChangeSortOrderOnClick)));
      this.colGrid.ForeColor = System.Drawing.SystemColors.WindowText;
      this.colGrid.Location = new System.Drawing.Point(16, 8);
      this.colGrid.Name = "colGrid";
      this.colGrid.NavigationBarButtons = NineRays.Windows.Forms.NavBarButton.All;
      this.colGrid.Opacity = 1;
      this.colGrid.Options = ((NineRays.Windows.Forms.Grids.GridOptions)(((NineRays.Windows.Forms.Grids.GridOptions.RowSelect | NineRays.Windows.Forms.Grids.GridOptions.ShowFocusRectangle) 
        | NineRays.Windows.Forms.Grids.GridOptions.Default)));
      // 
      // todoList.Rows
      // 
      this.colGrid.Rows.DefaultRowHeight = 18;
      this.colGrid.SelectedBackColor = System.Drawing.SystemColors.ControlDark;
      this.colGrid.Size = new System.Drawing.Size(504, 248);
      this.colGrid.TabIndex = 3;
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
      this.ClientSize = new System.Drawing.Size(536, 268);
      this.Controls.Add(this.colGrid);
      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
      this.Name = "Form1";
      this.Text = "FlyGrid with column with CheckedListBox as dropdown";
      this.Load += new System.EventHandler(this.Form1_Load);
      ((System.ComponentModel.ISupportInitialize)(this.colGrid)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void Form1_Load(object sender, System.EventArgs e)
    {
      InitAndFillGrid();
    }
    
    [Flags]
    [Editor(typeof(NineRays.Windows.Forms.Design.FlagsEnumEditor), typeof(System.Drawing.Design.UITypeEditor))]
    public enum SomeOptions
    {
      Empty = 0,
      Option1 = 1,
      Option2 = 2,
      Option3 = 4,
      Default = Option1 | Option3,
    }
    
    public enum SomeList
    {
      EmptyItem = 0,
      ListItem0,
      ListItem1,
      ListItem2,
      ListItem3,
    }

    private void InitAndFillGrid()
    {
      DynamicallyAutoDetectDataTypeColumn autoColumn_1 = new DynamicallyAutoDetectDataTypeColumn("Col1");
      DynamicallyAutoDetectDataTypeColumn autoColumn_2 = new DynamicallyAutoDetectDataTypeColumn("Col2");
      this.colGrid.Columns.Items.AddRange(new Column[]{autoColumn_1, autoColumn_2});
      //Fill cells
      //Prepare data
      object[] data = new object[]
        {
          new object[] {SomeList.EmptyItem, "None"},
          new object[] {SomeOptions.Default, "One"},
          new object[] {SomeList.ListItem2, 1},
          new object[] {1, SomeOptions.Empty},
          new object[] {SomeOptions.Option2, 22},
          new object[] {SomeList.ListItem0, "None"},
      };
      //create and add nodes with data
      foreach(object value in data)
      {
        this.colGrid.Rows.Items.Add(new Node(value));
      }
    }
	}
}
